//---------------------------------------------------------------------
//
// DispFntDlg.h : interface of the CDispFntDlg class
//
// Part of the FontViewer Utility, which first appeared
// in the May 26, 1998 issue of PC Magazine, U.S. Edition.
// Copyright (C) 1998 by Ziff-Davis, Inc. 
// Programmed by Jake Richter.
//
// The programs presented in PC Magazine can be copied but is copyright.
// You may make copies for others if no charge is involved, but copies
// or using any portion for any commerical purpose is strictly prohibited.
//
// For support, go to http://www.pcmag.com/discuss.htm and select 
// the Utilities area.
//
//---------------------------------------------------------------------
#if !defined(AFX_DISPFNTDLG_H__B8245281_8E49_11D1_B24F_0080ADB29FD7__INCLUDED_)
#define AFX_DISPFNTDLG_H__B8245281_8E49_11D1_B24F_0080ADB29FD7__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// DispFntDlg.h : header file
//

#define FONTSIZE  180      // Start at 18 points

/////////////////////////////////////////////////////////////////////////////
// CDispFntDlg dialog

class CDispFntDlg : public CDialog
{
// Construction
public:
   CDispFntDlg(CWnd* pParent = NULL);   // standard constructor
   CFontNode*  m_fontNode;       // Information on font we want to present
   BOOL        m_mouseClickDown; // Indicates we had a left button down event
   int         m_fontSize;       // Starting font size - set in DoModal();
   CString     m_fullName;       // Full Font name (including style, face)
   BOOL        m_typeOfShow;     // True = Character Set, False = AlphaNums

// Dialog Data
   //{{AFX_DATA(CDispFntDlg)
   enum { IDD = IDD_DISPFONT };
      // NOTE: the ClassWizard will add data members here
   //}}AFX_DATA


// Overrides
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CDispFntDlg)
   public:
   virtual int DoModal();
   protected:
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
   //}}AFX_VIRTUAL

// Implementation
protected:
   int      m_xStep;             // Cell width for grid
   int      m_yStep;             // Cell height for grid
   BOOL     m_displayed;         // Indicates that above two vars are valid

   void     ShowCharSet();
   void     ShowAlphaNums();

   // Generated message map functions
   //{{AFX_MSG(CDispFntDlg)
   afx_msg void OnPaint();
   afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
   afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
   virtual BOOL OnInitDialog();
   afx_msg void OnMouseMove(UINT nFlags, CPoint point);
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DISPFNTDLG_H__B8245281_8E49_11D1_B24F_0080ADB29FD7__INCLUDED_)
