//---------------------------------------------------------------------
//
// FVSetDlg.cpp : implementation file
//
// This file contains code to manage the FontViewer Display Settings
// dialog box. Much of it is just MFCAppWizard generated code.
//
// Part of the FontViewer Utility, which first appeared
// in the May 26, 1998 issue of PC Magazine, U.S. Edition.
// Copyright (C) 1998 by Ziff-Davis, Inc. 
// Programmed by Jake Richter.
//
// The programs presented in PC Magazine can be copied but is copyright.
// You may make copies for others if no charge is involved, but copies
// or using any portion for any commerical purpose is strictly prohibited.
//
// For support, go to http://www.pcmag.com/discuss.htm and select 
// the Utilities area.
//
//---------------------------------------------------------------------

#include "stdafx.h"
#include "FViewer.h"
#include "FVSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFVSetDlg dialog


CFVSetDlg::CFVSetDlg(CWnd* pParent /*=NULL*/)
   : CDialog(CFVSetDlg::IDD, pParent)
{
   SetDefaults();
   return;
}


void CFVSetDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CFVSetDlg)
   DDX_Text(pDX, IDC_EDIT_STRING, m_string);
   DDV_MaxChars(pDX, m_string, MAX_TEXT_STRING);
   DDX_CBString(pDX, IDC_COMBO_PTSIZE, m_ptSizeString);
   DDV_MaxChars(pDX, m_ptSizeString, 4);
   DDX_Check(pDX, IDC_CHECK_PLAIN, m_chkPlain);
   DDX_Check(pDX, IDC_CHECK_BOLD, m_chkBold);
   DDX_Check(pDX, IDC_CHECK_ITALIC, m_chkItalic);
   DDX_Check(pDX, IDC_CHECK_TRUETYPE, m_chkTrueType);
   DDX_Check(pDX, IDC_CHECK_BITMAP, m_chkBitmap);
   DDX_Check(pDX, IDC_CHECK_ANSI, m_chkANSI);
   DDX_Check(pDX, IDC_CHECK_NONANSI, m_chkNonANSI);
   DDX_Check(pDX, IDC_CHECK_SANSSERIF, m_chkSansSerif);
   DDX_Check(pDX, IDC_CHECK_SERIF, m_chkSerif);
   DDX_Check(pDX, IDC_CHECK_MODERN, m_chkModern);
   DDX_Check(pDX, IDC_CHECK_SCRIPT, m_chkScript);
   DDX_Check(pDX, IDC_CHECK_OTHER, m_chkOther);
   DDX_Check(pDX, IDC_CHECK_BOLDITAL, m_chkBoldItal);
   //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFVSetDlg, CDialog)
   //{{AFX_MSG_MAP(CFVSetDlg)
   ON_BN_CLICKED(IDC_BUTTON_DEFAULTS, OnButtonDefaults)
   ON_BN_CLICKED(IDC_CHECK_ANSI, OnCheckAnsi)
   ON_BN_CLICKED(IDC_CHECK_BITMAP, OnCheckBitmap)
   ON_BN_CLICKED(IDC_CHECK_BOLD, OnCheckBold)
   ON_BN_CLICKED(IDC_CHECK_ITALIC, OnCheckItalic)
   ON_BN_CLICKED(IDC_CHECK_MODERN, OnCheckModern)
   ON_BN_CLICKED(IDC_CHECK_NONANSI, OnCheckNonansi)
   ON_BN_CLICKED(IDC_CHECK_OTHER, OnCheckOther)
   ON_BN_CLICKED(IDC_CHECK_PLAIN, OnCheckPlain)
   ON_BN_CLICKED(IDC_CHECK_SANSSERIF, OnCheckSansserif)
   ON_BN_CLICKED(IDC_CHECK_SCRIPT, OnCheckScript)
   ON_BN_CLICKED(IDC_CHECK_SERIF, OnCheckSerif)
   ON_BN_CLICKED(IDC_CHECK_TRUETYPE, OnCheckTruetype)
   ON_BN_CLICKED(IDC_CHECK_BOLDITAL, OnCheckBoldItal)
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFVSetDlg message handlers

void CFVSetDlg::OnButtonDefaults() // Set Default values
{
   SetDefaults();
      UpdateData(FALSE);
   return;
}

/////////////////////////////////////////////////////////////////////////////
// CFVSetDlg routines

void CFVSetDlg::SetDefaults() // Set Default values
{
   m_string = _T("Test String - ABCDEFabcdef");
   m_ptSizeString = "12";
   m_chkPlain = TRUE;
   m_chkBold = FALSE;
   m_chkItalic = FALSE;
   m_chkTrueType = TRUE;
   m_chkBitmap = TRUE;
   m_chkANSI = TRUE;
   m_chkNonANSI = FALSE;
   m_chkSansSerif = TRUE;
   m_chkSerif = TRUE;
   m_chkModern = TRUE;
   m_chkScript = TRUE;
   m_chkOther = TRUE;
   return;
}

//---------------------------------------------------------------------
//
// The following four functions are used to post common message box
// errors. These are also called from FViewerView.cpp when similar
// toolbar button related problems occur.
//
//---------------------------------------------------------------------
void  CFVSetDlg::ErrBadStyleVariation()
{
   MessageBox("At least one style variation,\nNormal, Bold, Italic, or Bold-Italic,\nmust be enabled.",
            "Style Variation Selection Error",
            MB_ICONEXCLAMATION | MB_OK);
   return;
}

void  CFVSetDlg::ErrBadFontType()
{
   MessageBox("At least one font type,\nTrueType or Bitmap/Raster,\nmust be enabled.",
            "Font Type Selection Error",
            MB_ICONEXCLAMATION | MB_OK);
   return;
}

void  CFVSetDlg::ErrBadCharacterSet()
{
   MessageBox("At least one character set,\nANSI or Non-ANSI,\nmust be enabled.",
            "Character Set Selection Error",
            MB_ICONEXCLAMATION | MB_OK);
   return;
}

void  CFVSetDlg::ErrBadAttributeFilter()
{
   MessageBox("At least one attribute filter,\nSans Serif, Serif, etc.,\nmust be enabled.",
            "Attribute Filter Selection Error",
            MB_ICONEXCLAMATION | MB_OK);
   return;
}

//---------------------------------------------------------------------
//
// The following functions are used to validate the settings of the various
// check boxes. Each of the four groups of check boxes must have one or
// more selections enabled. If the user tries to turn off all selections,
// the routines below post an error message and force at least one of the
// selections to remain enabled.
//
//---------------------------------------------------------------------

void CFVSetDlg::OnCheckPlain() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkPlain || m_chkBold || m_chkItalic || m_chkBoldItal)
      return;        // No problem if at least one of them is enabled.

   m_chkPlain = TRUE;   // Keep it on
   ErrBadStyleVariation();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckBold() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkPlain || m_chkBold || m_chkItalic || m_chkBoldItal)
      return;        // No problem if at least one of them is enabled.

   m_chkBold = TRUE; // Keep it on
   ErrBadStyleVariation();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckItalic() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkPlain || m_chkBold || m_chkItalic || m_chkBoldItal)
      return;        // No problem if at least one of them is enabled.

   m_chkItalic = TRUE;  // Keep it on
   ErrBadStyleVariation();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckBoldItal() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkPlain || m_chkBold || m_chkItalic || m_chkBoldItal)
      return;        // No problem if at least one of them is enabled.

   m_chkBoldItal = TRUE;   // Keep it on
   ErrBadStyleVariation();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckTruetype() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkTrueType || m_chkBitmap)
      return;        // No problem if at least one of them is enabled.

   m_chkTrueType = TRUE;   // Keep it on
   ErrBadFontType();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckBitmap() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkTrueType || m_chkBitmap)
      return;        // No problem if at least one of them is enabled.

   m_chkBitmap = TRUE;  // Keep it on
   ErrBadFontType();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckAnsi() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkNonANSI || m_chkANSI)
      return;        // No problem if at least one of them is enabled.

   m_chkANSI = TRUE; // Keep it on
   ErrBadCharacterSet();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckNonansi() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkNonANSI || m_chkANSI)
      return;        // No problem if at least one of them is enabled.

   m_chkNonANSI = TRUE; // Keep it on
   ErrBadCharacterSet();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckSansserif() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkSansSerif || m_chkSerif || m_chkModern || m_chkScript || m_chkOther)
      return;        // No problem if one of the others is enabled.

   m_chkSansSerif = TRUE;  // Keep it on
   ErrBadAttributeFilter();
      UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckSerif() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkSansSerif || m_chkSerif || m_chkModern || m_chkScript || m_chkOther)
      return;        // No problem if one of the others is enabled.

   m_chkSerif = TRUE;   // Keep it on
   ErrBadAttributeFilter();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckModern() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkSansSerif || m_chkSerif || m_chkModern || m_chkScript || m_chkOther)
      return;        // No problem if one of the others is enabled.

   m_chkModern = TRUE;  // Keep it on
   ErrBadAttributeFilter();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckScript() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkSansSerif || m_chkSerif || m_chkModern || m_chkScript || m_chkOther)
      return;        // No problem if one of the others is enabled.

   m_chkScript = TRUE;  // Keep it on
   ErrBadAttributeFilter();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}

void CFVSetDlg::OnCheckOther() 
{
      UpdateData(TRUE); // Grab current state into our variables
   if (m_chkSansSerif || m_chkSerif || m_chkModern || m_chkScript || m_chkOther)
      return;        // No problem if one of the others is enabled.

   m_chkOther = TRUE;   // Keep it on
   ErrBadAttributeFilter();
   UpdateData(FALSE);   // Upload revised state to dialog
   return;  
}
