//---------------------------------------------------------------------
//
// FVSetDlg.h : Header for the FV Settings Dialog
//
// Part of the FontViewer Utility, which first appeared
// in the May 26, 1998 issue of PC Magazine, U.S. Edition.
// Copyright (C) 1998 by Ziff-Davis, Inc. 
// Programmed by Jake Richter.
//
// The programs presented in PC Magazine can be copied but is copyright.
// You may make copies for others if no charge is involved, but copies
// or using any portion for any commerical purpose is strictly prohibited.
//
// For support, go to http://www.pcmag.com/discuss.htm and select 
// the Utilities area.
//
//---------------------------------------------------------------------

#if !defined(AFX_FVSETDLG_H__F0A23B79_8BF4_11D1_B24F_0080ADB29FD7__INCLUDED_)
#define AFX_FVSETDLG_H__F0A23B79_8BF4_11D1_B24F_0080ADB29FD7__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// FVSetDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFVSetDlg dialog

class CFVSetDlg : public CDialog
{
// Construction
public:
   CFVSetDlg(CWnd* pParent = NULL);   // standard constructor

   //
   // The following are variables to match the controls in the dialog.
   //
// Dialog Data
   //{{AFX_DATA(CFVSetDlg)
   enum { IDD = IDD_FVSETTINGS };

   CString  m_string;
   CString  m_ptSizeString;
   BOOL     m_chkPlain;
   BOOL     m_chkBold;
   BOOL     m_chkItalic;
   BOOL     m_chkBoldItal;
   BOOL     m_chkTrueType;
   BOOL     m_chkBitmap;
   BOOL     m_chkANSI;
   BOOL     m_chkNonANSI;
   BOOL     m_chkSansSerif;
   BOOL     m_chkSerif;
   BOOL     m_chkModern;
   BOOL     m_chkScript;
   BOOL     m_chkOther;
   //}}AFX_DATA

// Overrides
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CFVSetDlg)
   protected:
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
   //}}AFX_VIRTUAL

protected:
// Implementation
   void  ErrBadStyleVariation();
   void  ErrBadFontType();
   void  ErrBadCharacterSet();
   void  ErrBadAttributeFilter();
   void  SetDefaults();

   // Generated message map functions
   //{{AFX_MSG(CFVSetDlg)
   afx_msg void OnButtonDefaults();
   afx_msg void OnCheckAnsi();
   afx_msg void OnCheckBitmap();
   afx_msg void OnCheckBold();
   afx_msg void OnCheckItalic();
   afx_msg void OnCheckModern();
   afx_msg void OnCheckNonansi();
   afx_msg void OnCheckOther();
   afx_msg void OnCheckPlain();
   afx_msg void OnCheckSansserif();
   afx_msg void OnCheckScript();
   afx_msg void OnCheckSerif();
   afx_msg void OnCheckTruetype();
   afx_msg void OnCheckBoldItal();
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FVSETDLG_H__F0A23B79_8BF4_11D1_B24F_0080ADB29FD7__INCLUDED_)
