//---------------------------------------------------------------------
//
// FVToolBar.cpp : implementation file
//
// This file contain code to handle FontViewer's custom toolbar.
//
// Part of the FontViewer Utility, which first appeared
// in the May 26, 1998 issue of PC Magazine, U.S. Edition.
// Copyright (C) 1998 by Ziff-Davis, Inc. 
// Programmed by Jake Richter.
//
// The programs presented in PC Magazine can be copied but is copyright.
// You may make copies for others if no charge is involved, but copies
// or using any portion for any commerical purpose is strictly prohibited.
//
// For support, go to http://www.pcmag.com/discuss.htm and select 
// the Utilities area.
//
//---------------------------------------------------------------------

#include "stdafx.h"
#include "resource.h"
#include "FViewer.h"
#include "FVToolBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFVToolBar

CFVToolBar::CFVToolBar()
{
}

CFVToolBar::~CFVToolBar()
{
}


BEGIN_MESSAGE_MAP(CFVToolBar, CToolBar)
   //{{AFX_MSG_MAP(CFVToolBar)
   ON_WM_CREATE()
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

//---------------------------------------------------------------------
//
// OnCreate
//
// This is where we add our combo box and list box to the toolbar, which
// already has space configured to all for the addition of these items.
//
//---------------------------------------------------------------------
int CFVToolBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
   CRect rect;
   CString str;

   if (CToolBar::OnCreate(lpCreateStruct) == -1)
      return -1;

   LoadToolBar(IDR_MAINFRAME);

   //
   // First do the string button/combo box.
   //
   SetButtonInfo(0, ID_BUTTON_STRING, TBBS_SEPARATOR, 208);

   GetItemRect(0, &rect);
   rect.bottom = rect.top + 160;

   m_stringBox.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL 
                  | CBS_DROPDOWN | CBS_AUTOHSCROLL,
                  rect, this, ID_BUTTON_STRING);
   m_stringBox.LimitText(MAX_TEXT_STRING);
   m_stringBox.AddString("Test String - ABCDEFabcdef");
   m_stringBox.AddString("Test String - ABCDEFabcdef");
   m_stringBox.AddString("Test String - 1234567890");
   m_stringBox.AddString("The quick brown fox jumps over the lazy dog");

   //
   // Now we need to copy the same set of strings to our local array.
   //
    m_stringBoxStrings.SetSize(4);  // Assume at least 4 elements ultimately in array

   for (int i = 0; i < m_stringBox.GetCount(); i++)
      {
      m_stringBox.GetLBText(i, str);      // Get string from list box
      m_stringBoxStrings.SetAtGrow(i, str);  // Store it in our array

      //
      // Next, let's see if we need to truncate the list box string and append "..."
      //
      if (str.GetLength() > MAX_LIST_STRING)
         {
         str = str.Left(MAX_LIST_STRING);
         str += "...";
         m_stringBox.DeleteString(i);
         m_stringBox.InsertString(i, str);   // Replace string in string box
         }
      }
   m_stringBox.SetCurSel(0);
   m_stringBox.SetWindowText(m_stringBoxStrings[0]);  // Put full string in edit box


   //
   // Now we do the point size box.
   //

   SetButtonInfo(1, ID_BUTTON_PTSIZE, TBBS_SEPARATOR, 50);

   GetItemRect(1, &rect);
   rect.bottom = rect.top + 200;
   rect.left += 4;
   rect.right += 4;

   m_ptSizeBox.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | CBS_DROPDOWNLIST,
                  rect, this, ID_BUTTON_PTSIZE);

   m_ptSizeBox.AddString("8");
   m_ptSizeBox.AddString("10");
   m_ptSizeBox.AddString("11");
   m_ptSizeBox.AddString("12");
   m_ptSizeBox.AddString("14");
   m_ptSizeBox.AddString("18");
   m_ptSizeBox.AddString("20");
   m_ptSizeBox.AddString("24");
   m_ptSizeBox.AddString("30");
   m_ptSizeBox.AddString("36");
   m_ptSizeBox.SetCurSel(3);
   
   return 0;
}

