//---------------------------------------------------------------------
//
// FViewer.cpp : Defines the class behaviors for the application.
//
// This file contains the main application set-up code for FontViewer.
// All generated by AppWizard.
//
// Part of the FontViewer Utility, which first appeared
// in the May 26, 1998 issue of PC Magazine, U.S. Edition.
// Copyright (C) 1998 by Ziff-Davis, Inc. 
// Programmed by Jake Richter.
//
// The programs presented in PC Magazine can be copied but is copyright.
// You may make copies for others if no charge is involved, but copies
// or using any portion for any commerical purpose is strictly prohibited.
//
// For support, go to http://www.pcmag.com/discuss.htm and select 
// the Utilities area.
//
//---------------------------------------------------------------------

#include "stdafx.h"
#include "FViewer.h"
#include "MainFrm.h"
#include "FViewerDoc.h"
#include "FViewerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFViewerApp

BEGIN_MESSAGE_MAP(CFViewerApp, CWinApp)
   //{{AFX_MSG_MAP(CFViewerApp)
   ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
   //}}AFX_MSG_MAP
   // Standard file based document commands
   ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
   ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
   ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFViewerApp construction

CFViewerApp::CFViewerApp()
{
   // TODO: add construction code here,
   // Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CFViewerApp object

CFViewerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFViewerApp initialization

BOOL CFViewerApp::InitInstance()
{
   // Standard initialization
   // If you are not using these features and wish to reduce the size
   //  of your final executable, you should remove from the following
   //  the specific initialization routines you do not need.

#ifdef _AFXDLL
   Enable3dControls();        // Call this when using MFC in a shared DLL
#else
   Enable3dControlsStatic();  // Call this when linking to MFC statically
#endif
   //
   // Set our INI file name - same directory as HLP file.
   //
   char  str[256];			// Path buffer
   memset(str, 0, 256);		// Need to clear buffer
							// Copy all of help path up to before the ".HLP"
   strncpy(str, m_pszHelpFilePath, strlen(m_pszHelpFilePath) - 4);
   strcat(str, ".INI");		// Append the ".INI" instead.
   free((void *)m_pszProfileName);	// Free old profile (INI) file name
   m_pszProfileName = _tcsdup(_T(str));	// Replace with the new

   // Register the application's document templates.  Document templates
   //  serve as the connection between documents, frame windows and views.

   CSingleDocTemplate* pDocTemplate;
   pDocTemplate = new CSingleDocTemplate(
      IDR_MAINFRAME,
      RUNTIME_CLASS(CFViewerDoc),
      RUNTIME_CLASS(CMainFrame),       // main SDI frame window
      RUNTIME_CLASS(CFViewerView));
   AddDocTemplate(pDocTemplate);

   // Parse command line for standard shell commands, DDE, file open
   CCommandLineInfo cmdInfo;
   ParseCommandLine(cmdInfo);

   // Dispatch commands specified on the command line
   if (!ProcessShellCommand(cmdInfo))
      return FALSE;

   //
   // The one and only window has been initialized, so show and update it.
   // We do this by reading from our INI file.
   //
   CString  section = INI_SECTION;
   char     strValue[10];
   char		outValue[10];
   WINDOWPLACEMENT	wndPlc;

   m_pMainWnd->GetWindowPlacement(&wndPlc);
   //
   // Finally, we get the window position.
   //
   _itoa(wndPlc.showCmd, outValue, 10); // Set the default window position
   GetPrivateProfileString(section, "WinShow", outValue, strValue, 10, m_pszProfileName);
   wndPlc.showCmd = atoi(strValue);     // Initial X position of Window

   _itoa(wndPlc.flags, strValue, 10); // Save the show state.
   GetPrivateProfileString(section, "WinFlag", outValue, strValue, 10, m_pszProfileName);
   wndPlc.flags = atoi(strValue);     // Initial X position of Window

   _itoa(wndPlc.rcNormalPosition.left, outValue, 10); // Set the default window position
   GetPrivateProfileString(section, "X1", outValue, strValue, 10, m_pszProfileName);
   wndPlc.rcNormalPosition.left = atoi(strValue);     // Initial X position of Window

   _itoa(wndPlc.rcNormalPosition.top, outValue, 10);
   GetPrivateProfileString(section, "Y1", outValue, strValue, 10, m_pszProfileName);
   wndPlc.rcNormalPosition.top = atoi(strValue);      // Initial Y position of Window

   _itoa(wndPlc.rcNormalPosition.right, outValue, 10);
   GetPrivateProfileString(section, "X2", outValue, strValue, 10, m_pszProfileName);
   wndPlc.rcNormalPosition.right = atoi(strValue);    // Set the width

   _itoa(wndPlc.rcNormalPosition.bottom, outValue, 10);
   GetPrivateProfileString(section, "Y2", outValue, strValue, 10, m_pszProfileName);
   wndPlc.rcNormalPosition.bottom = atoi(strValue);   // Set the height

   m_pMainWnd->SetWindowPlacement(&wndPlc);
   m_pMainWnd->UpdateWindow();

   //
   // Because the CDocument class SetTitle() function only modifies
   // part of the title bar in an SDI app like this, we need to go right
   // to the source to do it, and here in OnDraw() is the best place
   // to do so.
   //
   m_pMainWnd->SetWindowText("FontViewer"); // Set our window title.

   return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
   CAboutDlg();

// Dialog Data
   //{{AFX_DATA(CAboutDlg)
   enum { IDD = IDD_ABOUTBOX };
   //}}AFX_DATA

   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CAboutDlg)
   protected:
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
   //}}AFX_VIRTUAL

// Implementation
protected:
   //{{AFX_MSG(CAboutDlg)
      // No message handlers
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
   //{{AFX_DATA_INIT(CAboutDlg)
   //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CAboutDlg)
   //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
   //{{AFX_MSG_MAP(CAboutDlg)
      // No message handlers
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CFViewerApp::OnAppAbout()
{
   CAboutDlg aboutDlg;
   aboutDlg.DoModal();
   m_pMainWnd->Invalidate();
}

